<?php

require_once(dirname(__DIR__, 3).'/config/config.inc.php');

function exportAction($id_order)
{
    if ((trim(Configuration::get('KEYINVOICE_API_URL')) == '') || (trim(Configuration::get('KEYINVOICE_API_KEY')) == ''))
    {
        echo json_encode(array('msg'=> 'É necessário configurar a chave e/ou o url da API do KeyInvoice.'));
        return;
    }

    $client = new SoapClient(trim(Configuration::get('KEYINVOICE_API_URL')), array('cache_wsdl' => WSDL_CACHE_DISK)); 
	$result = $client->authenticate(trim(Configuration::get('KEYINVOICE_API_KEY')));

    if (intval($result[0]) !== 1)
	{
		echo json_encode(array('msg'=> utf8_decode($client->responseMessage($result[0], 0))));
        return;
	}
	
    $APISession = $result[1];
    $order = new Order((int)$id_order);

    $doc_type = Configuration::get('KEYINVOICE_DOCS');//tipo de documento
	$type     = (int)Configuration::get('KEYINVOICE_TYPE');//rascunho
    $ref      = Configuration::get('KEYINVOICE_REF');
    $email    = (int)Configuration::get('KEYINVOICE_EMAIL');
    $final_consumer = (int)Configuration::get('KEYINVOICE_ALLOW_FINAL_CONSUMER');

    $customer = new Customer($order->id_customer);
	$invoice_address = new Address($order->id_address_invoice);
	$country = new Country($invoice_address->id_country);
	$delivery_address = new Address($order->id_address_delivery);
	$country_delivery = new Country($delivery_address->id_country);

    if (($country->iso_code == 'PT') && (trim($invoice_address->vat_number) != ''))
	{
	    $result = $client->clientExists($APISession, trim($invoice_address->vat_number));
        if ($result[0] != 1)
        {
            $result = $client->insertClient(
                $APISession, 
                trim($invoice_address->vat_number), 
                utf8_encode($invoice_address->firstname.' '.$invoice_address->lastname), 
                utf8_encode($invoice_address->address1.' '.$invoice_address->address2), 
                utf8_encode($invoice_address->postcode), 
                utf8_encode($invoice_address->city), 
                $invoice_address->phone, 
                '',
                $customer->email,
                'API->PRESTASHOP'
            );					
			// se não conseguir criar o cliente, deve desistir desta encomenda!!
			if (intval($result[0]) != 1 ) 
			{
                return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' não foi exportada. '.utf8_decode($client->responseMessage($result[0], 0))));
			}
            if ($country_delivery->iso_code == 'PT')
			{
			    $client->insertAltAddress(
                    $APISession, 
					trim($invoice_address->vat_number), 
					utf8_encode($delivery_address->address1.' '.$delivery_address->address2), 
					utf8_encode($delivery_address->postcode), 
					utf8_encode($delivery_address->city)
                );
			}	
        }
        elseif ($result[0] == 1)
        {
            $result = $client->updateClient(
                $APISession, 
				trim($invoice_address->vat_number), 
				utf8_encode($invoice_address->firstname.' '.$invoice_address->lastname), 
				utf8_encode($invoice_address->address1.' '.$invoice_address->address2), 
				utf8_encode($invoice_address->postcode), 
				utf8_encode($invoice_address->city), 
				$invoice_address->phone, 
				'',
				$customer->email,
				'API->PRESTASHOP'
            );
        }
        $params = array( 
            'sid' => $APISession,
            'nif' => trim($invoice_address->vat_number),
            'docType' => $doc_type,
            'obs' => "PRESTASHOP ".$order->reference,
            'opt_name' => "",
            'opt_nif' =>"",
            'opt_address' =>"", 
            'opt_locality' =>"", 
            'opt_postalCode' =>"", 
            'docRef' => $ref.' '.$order->reference
        );
    }
    elseif (($country->iso_code != 'PT') && (trim($invoice_address->vat_number) != ''))
    {
        $result = $client->clientExists($APISession, trim($invoice_address->vat_number));
            
        if ($result[0] == -102)
        {
            $result = $client->insertForeignClient(
                $APISession, 
				trim($invoice_address->vat_number), 
				$country->iso_code,
				utf8_encode($invoice_address->firstname.' '.$invoice_address->lastname), 
				utf8_encode($invoice_address->address1.' '.$invoice_address->address2), 
				utf8_encode($invoice_address->postcode), 
				utf8_encode($invoice_address->city), 
				$invoice_address->phone, 
				'',
				$customer->email,
				'API->PRESTASHOP'
            );

            if (intval($result[0]) != 1 ) 
            {
                return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' não foi exportada. '.utf8_decode($client->responseMessage($result[0], 0))));
            }	
        }
        elseif ($result[0] == 1)
        {
            $result = $client->updateClient(
                $APISession, 
				trim($invoice_address->vat_number), 
				utf8_encode($invoice_address->firstname.' '.$invoice_address->lastname), 
				utf8_encode($invoice_address->address1.' '.$invoice_address->address2), 
				utf8_encode($invoice_address->postcode), 
				utf8_encode($invoice_address->city), 
				$invoice_address->phone, 
				'',
				$customer->email,
				'API->PRESTASHOP'
            );
        }
        $params = array(
            'sid' => $APISession,
			'nif' => trim($invoice_address->vat_number),
			'docType' => $doc_type,
			'obs' => "PRESTASHOP Encomenda ".$order->reference,
			'opt_name' => utf8_encode($invoice_address->firstname.' '.$invoice_address->lastname),
			'opt_nif' =>"",
			'opt_address' => utf8_encode($invoice_address->address1.' '.$invoice_address->address2), 
			'opt_locality' => utf8_encode($invoice_address->city), 
			'opt_postalCode' => utf8_encode($invoice_address->postcode), 
			'docRef' => $ref.' '.$order->reference
        );
    }
    elseif (($final_consumer == 1) && ((int)$doc_type != 13))
    {
        $params = array(
            'sid' => $APISession,
			'nif' => '',
			'docType' => $doc_type,
			'obs' => "PRESTASHOP Encomenda ".$order->reference,
			'opt_name' => utf8_encode($invoice_address->firstname.' '.$invoice_address->lastname),
			'opt_nif' =>"",
			'opt_address' => utf8_encode($invoice_address->address1.' '.$invoice_address->address2), 
			'opt_locality' => utf8_encode($invoice_address->city), 
			'opt_postalCode' => utf8_encode($invoice_address->postcode), 
			'docRef' => $ref.' '.$order->reference
        );
    }
    else if (((int)$doc_type == 13) && ($final_consumer == 1))
    {
        return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' não foi exportada. Não é possível exportar o documento do tipo Encomenda para um consumidor final.'));
    }
    else
    {
        return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' não foi exportada, não foi possivel criar cliente.'));
    }

    $result = insertDocumentHeader($client, $params);

	if (intval($result[0]) != 1)
    {
        return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' não foi exportada. '.utf8_decode($client->responseMessage($result[0], 0))));
	}	
			
	$idDocTemp = $result[1];
	$details = $order->getOrderDetailList();
	
	$pricelvlvat=verifyPriceLevelVAT($client,$APISession);	
	$priceswthvat=verifyUserInsertionPricesWithVAT($client,$APISession);
 
    foreach($details as $detail)
	{	
		unset($tax);
		$order_detail_tax = getDetailTax($detail['id_order_detail']);
     
        if (is_array($order_detail_tax) && !empty($order_detail_tax))
		{
			$tax = new Tax((int)$order_detail_tax[0]['id_tax'], true);
		}
    
        $product = new Product((int)$detail['product_id']);
		$tax_rate=0;
		if(isset($tax->rate)) $tax_rate=$tax->rate;
				
        $result = $client->productExists($APISession, $product->reference);
        
        if ($result[0]  == -204)
        {
			$product_price_lvl=$product->price;
			if($pricelvlvat) $product_price_lvl=round($product_price_lvl * (1 + ($tax_rate/100)),2);
			
            $params = array(
                'sid' => $APISession,
				'ref' => $product->reference,
				'designation' => utf8_encode($product->name[(int)Configuration::get('PS_LANG_DEFAULT')]),
				'shortName' => utf8_encode($product->name[(int)Configuration::get('PS_LANG_DEFAULT')]),
				'tax' => $tax_rate,
				'obs' => '',
				'isService' => '0',
				'hasStocks' => '1',
				'active' => '1',
				'shortDesc' => utf8_encode(htmlspecialchars_decode($product->description_short[(int)Configuration::get('PS_LANG_DEFAULT')])),
				'longDesc' => utf8_encode(htmlspecialchars_decode($product->description[(int)Configuration::get('PS_LANG_DEFAULT')])),
				'price' => $product_price_lvl,
				'vendorRef' => '',
				'ean' => $product->ean13
            );
				
			$result = $client->__soapCall('insertProduct', $params);

            if (intval($result[0]) != 1)
            {
                return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' foi exportada com erros. '.utf8_decode($client->__soapCall('responseMessage', array($result[0], 0)))));
            }	
			
            $id_image = Product::getCover($product->id);
            if (sizeof($id_image) > 0) 
            {
                $image = new Image($id_image['id_image']);
                if ($image->id)
                {
                    $IMG = $image->getExistingImgPath();

                    if ($image->image_format == 'jpg')
                    {
                        $image_url = _PS_BASE_URL_._THEME_PROD_DIR_.$IMG.'.'.$image->image_format;
                        if (file_exists(_PS_PROD_IMG_DIR_.$IMG.'.'.$image->image_format))
                        {
                            if ($IMG != "")
                            {
                                $result = $client->insertProductImageByURL($APISession, $product->reference, $image_url);
                            }
                        }
                    }
                }
            }
        }
        $discount = 0;
        if ($detail['reduction_percent'] > 0) $discount = $detail['reduction_percent']; 
		if ($detail['reduction_amount_tax_excl'] > 0) $discount = ($detail['reduction_amount_tax_excl'] / ($detail['original_product_price'])) * 100;
		
		$product_price_ln=$detail['original_product_price'];
		if($priceswthvat) $product_price_ln=round($product_price_ln * (1 + ($tax_rate/100)),2);
		
        $params = array(
            'sid' => $APISession,
			'idDocTemp' => $idDocTemp,
			'docType' => $doc_type,
			'ref' => $product->reference,
			'qt' => $detail['product_quantity'],
			'price' => $product_price_ln,
			'tax' => (($tax) ? $tax_rate : '0'),
			'prodDesc' => utf8_encode($product->name[(int)Configuration::get('PS_LANG_DEFAULT')]),
			'discount' => $discount
		);

		$result = insertDocumentLine($client, $params);
			
		if (intval($result[0]) != 1)
        {
            return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' foi exportada com erros. '.utf8_decode($client->__soapCall('responseMessage', array($result[0], 0)))));
		}
	}
	if ($order->total_shipping > 0)
	{
		$params = array(
			'sid' => $APISession,
			'idDocTemp' => $idDocTemp,
			'docType' => $doc_type,
			'ref' => '',
			'qt' => 1,
			'price' => $order->total_shipping_tax_excl,
			'tax' => $order->carrier_tax_rate,
			'prodDesc' => 'PrestaShop Shipping',
			'discount' => ''
		);
		
		$result = insertDocumentLine($client, $params);
		
		if (intval($result[0]) != 1)
		{
			return json_encode(array('msg' => '- Encomenda com a Referência '.$order->reference.' foi exportada com erros. '.utf8_decode($client->__soapCall('responseMessage', array($result[0], 0)))));
		}	
	}
			
	if ($type == 0)
	{
		$doc_result = $client->closeDocument($APISession, $idDocTemp, $doc_type);
		if (intval($doc_result[0]) != 1)
		{
			return json_encode(array('msg' => '- '.utf8_decode($client->responseMessage($doc_result[0], 0))));
		}
  
		$doc = getDocument($client, $APISession, $doc_result[1], $doc_type);
		if (!$doc)
		{
			return json_encode(array('msg'=> '- Não foi possível associar o documento da encomenda.'));
		}	

		$document_key = $doc->IdDoc.'_'.$doc->DocType.'_'.$doc->DocSeries;
		//gravar na bd junto da order_id?
		//varificar se as keys são as mesmas?? ver a order_id;
		$doc_old_key = Db::getInstance()->getRow('SELECT `_keyinvoice_document_id`
				FROM `'._DB_PREFIX_.'orders`
				WHERE `id_order` = \''.pSQL($order->id).'\'');
		
		if (is_array($doc_old_key) && !empty($doc_old_key['_keyinvoice_document_id']))
		{
			if ($doc_old_key['_keyinvoice_document_id'] != $document_key)
			{
				Db::getInstance()->execute("UPDATE "._DB_PREFIX_."orders SET _keyinvoice_document_id = '".$document_key."' WHERE id_order = '".$order->id."'");
			}
		}
		else
		{
			Db::getInstance()->execute("UPDATE "._DB_PREFIX_."orders SET _keyinvoice_document_id = '".$document_key."' WHERE id_order = '".$order->id."'");
		}

		if (($email == 1) && ($customer->email != ""))
		{
			$body = utf8_encode('Caro(a) '.$invoice_address->firstname.' '.$invoice_address->lastname.', <br/><br/>
				Enviamos em anexo a factura relativa à sua encomenda nº '.$order->reference.', datada de '.date('Y-m-d H:i', strtotime($order->date_add)).'. <br/>');
			
			$result = sendDocumentPDF2Email(
				$client,
				$APISession,
				$doc_result[1],
				$doc_type, 
				utf8_encode($customer->email), 
				utf8_encode('Envio do documento relativo à encomenda nº '.$order->reference),
				$body 
			);
			if ($result !== true)
			{
				return json_encode(array('msg'=> '- Erro ao enviar email. '.utf8_decode($client->responseMessage($result[0], 0)))); 
			}
		}
	}
	
    return json_encode(array('msg' => 'Importaçao Finalizada com sucesso!'));
}

function verifyPriceLevelVAT($client,$APISession){
	$result = $client->verifyPriceLevelVAT($APISession);	
	if($result[0] == 1)
	{
		return $result[1];
	} 
	return 0;
}
function verifyUserInsertionPricesWithVAT($client,$APISession){
	$result = $client->verifyUserInsertionPricesWithVAT($APISession);	
	if($result[0] == 1)
	{
		return $result[1];
	} 
	return 0;
}
function insertDocumentHeader($soap, $params)
{
    return $soap->insertDocumentHeader(
        $params['sid'],
        $params['nif'],
        $params['docType'],
        $params['obs'],
        $params['opt_name'],
        $params['opt_nif'],
        $params['opt_address'], 
        $params['opt_locality'], 
        $params['opt_postalCode'], 
        $params['docRef']
    );
}

function insertDocumentLine($soap, $params)
{
    return $soap->insertDocumentLine( 
        $params['sid'], 
        $params['idDocTemp'],
        $params['docType'],
        $params['ref'],
        $params['qt'],
        $params['price'],
        $params['tax'],
        $params['prodDesc'],
        $params['discount']
    );
}

function getDocument($soap, $sid, $doc, $type)
{
    $result = $soap->getDocument($sid, $doc, $type);
    if ($result->RC == 1)
    {
        return $result->DAT[0];
    } 
    return false;
}

function sendDocumentPDF2Email($client, $sid, $doc, $doc_type, $email, $subject, $body)
{
    $result = $client->sendDocumentPDF2Email(
        $sid,
        $doc,
        $doc_type,
        $email, 
        $subject,
        $body
    );
    if ($result[0] == 1)
    {
       return true;
    }
    return $result;
}

function getDetailTax($id_order_detail)
{	
    $query = new DbQuery();
    $query->select('tax.*');
    $query->from('order_detail_tax', 'tax');
    $query->join('LEFT JOIN `'._DB_PREFIX_.'order_detail` od ON (tax.`id_order_detail` = od.`id_order_detail`)');
    $query->where('od.`id_order_detail` = '.(int)$id_order_detail);

    return Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS($query);
}

function getPDFLink($document)
{
    $soap = new SoapClient(trim(Configuration::get('KEYINVOICE_API_URL')), array('cache_wsdl' => WSDL_CACHE_DISK)); 
    $conn = $soap->authenticate(trim(Configuration::get('KEYINVOICE_API_KEY')));
   
    $keyinvoice_document_ids = explode('_',$document);
    $result = $soap->getDocumentPDFLink_bySeries(
        $conn[1],
        $keyinvoice_document_ids[0],
        $keyinvoice_document_ids[1],
        $keyinvoice_document_ids[2]
    );
    if ($result[0] == 1)
    {
        return $result[1];
    } 
    return false; 
}

function pdf_page($order_id)
{
    $order = new Order($order_id);
    $document = Db::getInstance()->getRow('SELECT `_keyinvoice_document_id`
        FROM `'._DB_PREFIX_.'orders`
        WHERE `id_order` = \''.pSQL($order->id).'\'');

    if (trim($document['_keyinvoice_document_id']) != '')
    {
		$result = getPDFLink($document['_keyinvoice_document_id']);

    	$keyinvoice_document_ids = explode('_',$document['_keyinvoice_document_id']);

        $f_name = $keyinvoice_document_ids[1].$keyinvoice_document_ids[2].$keyinvoice_document_ids[0];

    	header("Expires: 0");
		header("Cache-Control: no-cache, no-store, must-revalidate"); 
		header('Cache-Control: pre-check=0, post-check=0, max-age=0', false); 
		header("Pragma: no-cache");	
		header("Content-type: application/pdf");
		header('Content-Disposition: attachment; filename="'.$f_name.'.pdf"');
		header("Content-Type: application/force-download");

		ob_clean();
		flush();
		readfile($result);
		exit();
    }
	exit();
}

$req = $_POST;
$action = $req['action'];
$id_order = $req['order_id'];

switch ($action) 
{
    case 'export_document': 
    {
        echo exportAction($id_order);
        break;
    }
    case 'generate_pdf':
    {
        pdf_page($id_order);
        break;
    }
    default: break;
}